From db8e7e3182d382b3a83d12d0630dc501b7db9197 Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jan 30 2022 14:25:48 +0000
Subject: [PATCH 66/88] add localization support for asciidoc attributes


---

diff --git a/build-scripts/rebuild-site.py b/build-scripts/rebuild-site.py
index 823c1bd..3c34c87 100755
--- a/build-scripts/rebuild-site.py
+++ b/build-scripts/rebuild-site.py
@@ -17,7 +17,7 @@
 #
 
 
-import tempfile, yaml, os, errno, subprocess, copy, datetime, shutil, sys
+import tempfile, yaml, os, errno, subprocess, copy, datetime, shutil, sys, glob
 
 
 def get_config():
@@ -39,6 +39,10 @@ def get_config():
         "TRANSLATED_SOURCES_REPO_URL",
         "https://pagure.io/fedora-docs/translated-sources.git"
     )
+
+    config["translated_adockeywords_repo_url"] = os.getenv(
+        "TRANSLATED_ADOCKEYWORDS_REPO_URL",
+        "https://pagure.io/fedora-docs-l10n/asciidoc-keywords.git")
     
     return config
 
@@ -218,6 +222,30 @@ def prepare_translated_sources(translated_sources, site_yml, languages, config):
     return components
 
 
+def prepare_localized_admonitions(languages, config):
+    """ Asciidoc use keywords for admonitions and others items """
+    keywords = {}
+
+    with tempfile.TemporaryDirectory() as workdir:
+        translated_keywords_repo = os.path.join(workdir, "asciidoc-keywords")
+        subprocess.run(["git", "clone", config["translated_adockeywords_repo_url"], translated_keywords_repo])
+
+        languages = []
+        log(translated_keywords_repo + "/langs/*/asciidoc-attributes.yml")
+        for filename in glob.glob(translated_keywords_repo + "/langs/*/asciidoc-attributes.yml"):
+            languages.append(filename.rsplit("/")[::-1][1])
+
+        for lang in languages:
+            file = translated_keywords_repo + "/langs/" + lang + "/asciidoc-attributes.yml"
+            with open(file, 'r') as stream:
+                try:
+                    keywords[lang] = yaml.load(stream)
+                except yaml.YAMLError as exc:
+                    print(exc)
+
+    return keywords
+
+
 def init_git_repo(path):
     try:
         os.makedirs(path)
@@ -328,6 +356,10 @@ def main():
             components = prepare_translated_sources(translated_sources, original_site_yml, languages, config)
 
             log("")
+            log("===== Preparing the translated ascidoc keywords =====")
+            keywords = prepare_localized_admonitions(languages, config)
+
+            log("")
             log("===== Generating site.lang.yml files =====")
             for lang in languages:
                 lang_site_yml = copy.deepcopy(original_site_yml)
@@ -351,6 +383,12 @@ def main():
 
                         lang_site_yml["content"]["sources"].append(source)
 
+                if lang in keywords:
+                    if "attributes" in lang_site_yml["asciidoc"]:
+                        lang_site_yml["asciidoc"]["attributes"].append(keywords[lang])
+                    else:
+                        lang_site_yml["asciidoc"]["attributes"] = keywords[lang]
+
                 filename = os.path.join(docs_repo, "site-{lang}.yml".format(lang=lang))
                 with open(filename, "w") as file:
                     file.write(yaml.dump(lang_site_yml))

